=head1 NAME

remote_tail.pl - tail for remote host

=head1 SYNOPSIS

S<remote_tail.pl [config file]>

=head1 DESCRIPTION

remote host  telnet ŃOCAtail R}h𔭍sB

ڑݒ蓙 remote_tail.yml ɋLq邱ƁB

=cut

use strict;
use warnings;

=head1 PACKAGES

=head2 RemoteLogger

=head3 DESCRIPTION

[gT[o telnet ŐڑÃR}h𔭍sNXB
O͕Wo͂ɏo͂B

=cut

package RemoteLogger;

use Jcode;
use POSIX 'strftime';

our @loggers = ();

=head3 METHODS

=cut

=head4 new(%config)

RXgN^B

	{
		Name		=> 'server01 access_log',
		Host		=> '192.168.0.1',
		LoginSeq	=> [
			{	'/Username:/'	=> 'user' },
			{	'/Password:/'	=> 'pass' },
		],
		Command		=> 'tail -f /usr/local/apache/logs/access_log | grep 404',
		ForeGround	=> '#ff8080',
	}

̂悤ȔznB

=cut

sub new
{
	my $class = shift @_;
	my $self = { @_ };
	
	bless($self, $class);
	
	push @loggers, $self;
	
	$self->init();
	
	return $self;
}

=head4 init()

\bhB
Net::Telnet IuWFNg쐬AOCAR}hssB

=cut

sub init
{
	my $self = shift @_;
	
	# R}h̕ҏW
	my $command = $self->{Command};
	$command = strftime($command, localtime());
	
	# Login
	$self->log("*** Log in ***\n");
	my $t = Net::Telnet->new(
		Timeout => 5,
		Host	=> $self->{Host},
	);
	
	foreach my $seq (@{$self->{LoginSeq}}) {
		my ($waitfor, $print) = %$seq;
		$t->waitfor($waitfor) && $t->print($print);
	}
	
	$t->print($command);
	$self->print($self->{Command} . "\n");
	
	$self->{Terminal} = $t;
}

=head4 flush()

Net::Telnet IuWFNg󂯎OA
log() gďo͂B

=cut

sub flush
{
	my $self = shift @_;
	
	my $t = $self->{Terminal};
	
	eval {
		while (my $data = $t->getline(Timeout => 0)) {
			$self->log($data);
		}
	};
	
	if ($@) {
		if ($@ =~ /^read timed-out/) {
			# OK
		}
		else {
			die $@;
		}
	}
}

=head4 log($line)

nꂽɎԓtAprint() ŏo͂B

=cut

sub log
{
	my $self = shift @_;
	my $line = shift @_;
	
	$line = sprintf(
		"%02d:%02d:%02d %s: %s",
		(localtime())[2, 1, 0],
		$self->{Name},
		$line
	);
	$self->print($line);
}

=head4 print($line)

nꂽWo͂ɏo͂B
KXI[o[ChĎgp̂ƁB

=cut

sub print
{
	my $self = shift @_;
	my $line = shift @_;
	
	$| = 1;
	$line = jcode($line)->sjis;
	print $line;
}

=head4 start_logging

Ȍo͂JnB
NXϐƂĎgpĂB

=cut

sub start_logging
{
	my $self = shift @_;
	
	while (1) {
		foreach my $logger (@loggers) {
			$logger->flush();
		}
		
		sleep(1);
	}
}

=head4 DESTROY()

fXgN^BNet::Telnet ̐ؒfsB

=cut

sub DESTROY
{
	my $self = shift @_;
	
	if ($self->{Terminal}) {
		$self->{Terminal}->close();
	}
}

=head2 RemoteLogger::Tk

=head3 DESCRIPTION

RemoteLogger ̃TuNXB
Tk gpăOo͂B

=cut

package RemoteLogger::Tk;

use Encode;
use Jcode;
use Tk;

our @ISA = qw(RemoteLogger);

our $top;
our $text;
our $tk_inited = undef;

=head3 METHODS

=cut

=head4 init()

RemoteLogger ̏ɉATk::Text ̃^Oݒ肵ĂB

=cut

sub init
{
	my $self = shift @_;
	
	if (!$tk_inited) {
		tk_init();
		$tk_inited = 1;
	}
	
	# ^O̍쐬
	my $tagname = $self->{Name};
	$tagname =~ s/\s+//g;
	
	$text->tagConfigure(
		$tagname,
		'foreground' => $self->{ForeGround},
		#~ 'background' => $self->{BackGround},
	);
	$self->{TagName} = $tagname;
	
	$self->SUPER::init();
}

=head4 tk_init()

Tk ̏s

=cut

sub tk_init
{
	# R}hEBhE
	if ($^O eq 'MSWin32' &&
		!$INC{'PAR.pm'})	# PAR ɂꍇA--gui őΉ邽ߕsv
	{
		require Win32::Console;
		Win32::Console::Free();
	}

	# initialize
	$top = MainWindow->new();
	$top->title('remote_tail');

	$text = $top->Scrolled('Text', -scrollbars => 'e')->pack(-expand => 1, -fill => 'both');
}

=head4 print()

Tk::Text ɏo͂sB

=cut

sub print
{
	my $self = shift @_;
	my $line = shift @_;
	
	$line = jcode($line)->utf8;
	$line = decode_utf8($line);
	
	$text->insert('end', $line, $self->{TagName});
	$text->yviewMoveto(1);
	$top->update();
}

=head4 start_logging

Ȍo͂JnB
ł MainLoop ĂяoB

=cut

sub start_logging
{
	my $self = shift @_;
	
	$top->after(0, \&log_all);
	
	MainLoop();
}

=head4 log_all()

쐬SĂ RemoteLogger::Tk IuWFNgɑ΂āA
flush ĂяoB

=cut

sub log_all
{
	foreach my $logger (@loggers) {
		$logger->flush();
	}
	$top->after(1000, \&log_all);
}

=head2 main

=head3 DESCRIPTION

RemoteLogger::Tk gpăOo͂B

=cut

package main;

use Net::Telnet;
use YAML qw/LoadFile/;
use Data::Dumper;

# Load Settings
my $conf_file = $ARGV[0] || 'remote_tail.yml';
my $logger_settings = LoadFile($conf_file);

foreach my $setting (@$logger_settings) {
	while (my ($name, $command) = each %{$setting->{Commands}}) {
		my %simple_logger = (
			Host		=> $setting->{Host},
			LoginSeq	=> $setting->{LoginSeq},
			Name		=> $name,
			%$command,
		);
		my $logger = RemoteLogger::Tk->new(%simple_logger)
			or die "Can't create logger: " . Dumper(%simple_logger);
	}
}

RemoteLogger::Tk::start_logging();

exit(0);

